<?php
class Gateway {
	private $_module;
	private $_basket;

	public function __construct($module = false, $basket = false) {
		$this->_module	= $module;
		$this->_basket =& $GLOBALS['cart']->basket;
		
		$this->_server	= ($this->_module['test_mode']) ? 'secure2.mde.epdq.co.uk' : 'secure2.epdq.co.uk';
		$this->_path	= '/cgi-bin/CcxBarclaysEpdq.e';
	}

	##################################################

	public function transfer() {
		$transfer	= array(
			'action'	=> 'https://'.$this->_server.$this->_path,
			'method'	=> 'post',
			'target'	=> '_self',
			'submit'	=> 'auto',
		);
		return $transfer;
	}

	public function repeatVariables() {
		return false;
	}

	public function fixedVariables() {
		$request_data	= array(
			'clientid'		=> $this->_module['clientid'],
			'oid'			=> $this->_basket['cart_order_id'],
			'password'		=> $this->_module['passphrase'],
			'total'			=> $this->_basket['total'],
			'currencycode'	=> '826',
			'chargetype'	=> $this->_module['charge_type'],
		);

		//@todo What if there is no CURL!?
		$ch	= curl_init();
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($request_data, '', '&'));
		curl_setopt($ch, CURLOPT_URL, 'https://'.$this->_server.'/cgi-bin/CcxBarclaysEpdqEncTool.e');
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  2);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		$result	= curl_exec($ch);
		
		/* This should work and I've just not been able to see why it doesn!!
		$request = new Request($this->_server, $this->_path);
		$request->setData($request_data);
		$request->setSSL();
		$response = $request->send();
		*/
		
		if ((bool)curl_errno($ch) == false) {
			curl_close($ch);
			//Parse their dirty html response
			if (preg_match('#value="([A-Z0-9]+)"#iu', $result, $match)) {
				
				$hidden	= array(
					'epdqdata'				=> $match[1],
					'returnurl'				=> $GLOBALS['storeURL'].'/modules/gateway/BarclayCard/return.php',
					'merchantdisplayname'	=> $GLOBALS['config']->get('config', 'store_name'),

					'email'				=> $this->_basket['billing_address']['email'],
					## Billing data
					'bfullname'			=> $this->_basket['billing_address']['first_name'].' '.$this->_basket['billing_address']['last_name'],
					'baddr1'			=> $this->_basket['billing_address']['line1'],
					'baddr2'			=> $this->_basket['billing_address']['line2'],
					'bcity'				=> $this->_basket['billing_address']['town'],
					'bpostalcode'		=> $this->_basket['billing_address']['postcode'],
					'bcountry'			=> $this->_basket['billing_address']['country_iso'],
					'btelephonenumber'	=> $this->_basket['billing_address']['phone'],
					## Shipping Data
					'sfullname'		=> $this->_basket['delivery_address']['first_name'].' '.$this->_basket['delivery_address']['last_name'],
					'saddr1'		=> $this->_basket['delivery_address']['line1'],
					'saddr2'		=> $this->_basket['delivery_address']['line2'],
					'scity'			=> $this->_basket['delivery_address']['town'],
					'spostalcode'	=> $this->_basket['delivery_address']['postcode'],
					'scountry'		=> $this->_basket['delivery_address']['country_iso'],
				);

				if ($hidden['bcountry'] == 'US') {
					$hidden['bstate']	= $this->_basket['billing_address']['state'];
				} else {
					$hidden['bcountyprovince'] = $this->_basket['billing_address']['state'];
				}

				if ($hidden['scountry'] == 'US') {
					$hidden['sstate']	= $this->_basket['delivery_address']['state'];
				} else {
					$hidden['scountyprovince'] = $this->_basket['delivery_address']['state'];
				}
			}
		}
		return (isset($hidden)) ? $hidden : false;
	}

	##################################################

	public function call() {
		/* Available Parameters
			 transactionstatus  The outcome of the authorisation request. 
			 oid  The Order ID value. 
			 total  The transaction amount. 
			 clientid  Your unique ePDQ identifier. 
			 chargetype  The type of transaction you requested. 
			 datetime  Date and time of order. 
			 ecistatus  The outcome of the Internet Authentication process. 
			 cardprefix  First digit of the cardholders card number. 
		*/
		//if ($_SERVER['PHP_AUTH_USER'] == $this->_module['post_user'] && $_SERVER['PHP_AUTH_PW'] == $this->_module['post_pass']) {
			$proceed 	= true;
			if ($_POST['clientid'] != $this->_module['clientid'] || !isset($_POST['transactionstatus'])) {
				$proceed = false;
			}
			if ((bool)$proceed) {
				$order	= Order::getInstance();
				$order->getSummary($_POST['oid']);
				switch ($_POST['transactionstatus']) {
					case 'Success':
						$transData['status']	= 'Success';
						$order->orderStatus(Order::ORDER_PROCESS, $_POST['oid']);
						break;
					default:
						$transData['status']	= 'Declined';
						$order->orderStatus(Order::ORDER_CANCELLED, $_POST['oid']);
				}
				## Build the transaction log data
				$transData['gateway']		= $_GET['module'];
				$transData['order_id']		= $_POST['oid'];
				$transData['trans_id']		= '';
				$transData['amount']		= $_POST['total'];
				$transData['customer_id']	= $order->orderSum['customer_id'];
				$transData['notes']			= $_POST['transactionstatus'];
				$order->logTransaction($transData);
			}
		/*
		} else {
			header('WWW-Authenticate: Basic realm="Payment"');
			header('HTTP/1.0 401 Unauthorized');
		}
		*/
	}

	public function process() {
		if (($status = $GLOBALS['db']->select('CubeCart_order_summary', 'status', array('cart_order_id' => $_GET['cart_order_id']))) !== false) {
			$cart_order_id = $_GET['cart_order_id'];
			switch($status[0]['status']) {
				case 2:
				case 3:
					$paymentResult = 2;
					break;
				default:
					$paymentResult = 1;
			}
			httpredir(currentPage(array('_g', 'type', 'cmd', 'module'), array('_a' => 'complete')));
		}
	}

	public function form() {
		return false;
	}
}